---
title: Create Custom Adorners
product: Survey Creator
description: Custom adorner actions ensure even easier management of your survey elements right on the design surface. View a free demo example for JavaScript to learn more.
framework: Vanilla JS
source: https://surveyjs.io/survey-creator/examples/create-custom-adorners/vanillajs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Create Custom Adorners (Vanilla JS)

Adorners are interactive design-surface controls placed within a question area. Adorners allow users to quickly execute the most common actions: duplicate a question, mark a question as required, or delete it. This demo shows how to customize built-in adorners and create custom adorners.

## Create a Button Adorner

A button adorner executes a simple action on click. To create a button adorner, follow the steps below:

1. Handle the [`onElementGetActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onElementGetActions) event.        
This event is raised when Survey Creator renders adorners on the design surface.

2. Create an `Action` instance.        
Pass an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) configuration object to the `Action` constructor. This object describes an action item rendered as a button adorner.

3. Add the `Action` instance to the `options.actions` array.       

This demo shows how to create a custom Read-Only button adorner. Refer to the code listing for more information. 

## Create a Drop-Down Adorner

A drop-down adorner opens a drop-down menu on click. The following instructions describe how to create a drop-down adorner:

1. Handle the [`onElementGetActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onElementGetActions) event.

2. Create an `Action` instance.     
Drop-down adorners have a dedicated `createDropdownActionModel()` helper function that generates `Action` instances based on [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) and `IActionDropdownPopupOptions` configuration objects. Import this function from `survey-core` and pass `IAction` and `IActionDropdownPopupOptions` objects to it.

3. Add the `Action` instance to the `options.actions` array.

In this demo, a custom Sort Order drop-down adorner lets users specify the order of items in choice-based questions. For details about implementation, view code listings for Angular, React, Vue, jQuery, or Vanilla JavaScript.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/survey_json.js`

```js
export const surveyJSON = {
  "elements": [
    {
      "type": "text",
      "name": "Single-Line Input"
    },
    {
      "type": "checkbox",
      "name": "Checkboxes",
      "choices": [
        "Item 1",
        "Item 2",
        "Item 3"
      ]
    }
  ]
};
```

### `src/index.js`

```js
import { SurveyCreator } from "survey-creator-js";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Serializer, Action, ComputedUpdater, createDropdownActionModel, QuestionSelectBase } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

const creator = new SurveyCreator();

function createReadOnlyAction(question) {
    return new Action({
        id: "readOnly",
        active: new ComputedUpdater(() => question.readOnly),
        title: "Read-Only",
        iconName: "icon-editing-finish",        
        action: () => {
            question.readOnly = !question.readOnly;
        },
        // Place Read-Only before the Duplicate adorner whose `visibleIndex` is 10
        visibleIndex: 9
    });
}
function createSortOrderAction(selectBaseQuestion) {
    const sortOrderOptions = [
        { id: "none", title: "None" },
        { id: "asc", title: "Ascending" },
        { id: "desc", title: "Descending" },
        { id: "random", title: "Random" }
    ];
    function getTitle(selectBaseQuestion) {
        return sortOrderOptions.filter(
          (order) => order.id === selectBaseQuestion.choicesOrder
        )[0].title;
    }
    return createDropdownActionModel(
        {
            id: "sortOrder",   
            // Update a title caption to display the currently selected choice order
            title: new ComputedUpdater(() => {
                return getTitle(selectBaseQuestion);

            }),
            // Place Sort Order before the custom Read-Only adorner
            visibleIndex: 8,
            // With the `sv-action--convertTo` class, a drop-down adorner
            // displays the selected value instead of the title
            css: "sv-action--convertTo sv-action-bar-item--secondary"            
        },
        {
            items: sortOrderOptions,
            allowSelection: true,
            onSelectionChanged: (item) => {
                selectBaseQuestion.choicesOrder = item.id;
            },
            verticalPosition: "top",
            horizontalPosition: "center"
        }
    );
}
creator.onElementGetActions.add((_, options) => {
    const question = options.element;
    // Hide the titles of built-in adorners, except for "Element Type" and "Input Type"
    options.actions.forEach((action) => {
        if (["convertTo", "convertInputType"].indexOf(action.id) < 0) {
            action.showTitle = false;
        }
    });
    // Create a "Read-only" adorner for all question types
    const readOnlyAdorner = createReadOnlyAction(question);
    options.actions.push(readOnlyAdorner);

    // Create a "Sort Order" adorner for all choice-based questions
    if (question instanceof QuestionSelectBase) {
        const sortOrderAdorner = createSortOrderAction(question);
        options.actions.push(sortOrderAdorner);
    }
});

creator.JSON = surveyJSON;
creator.render("surveyCreatorContainer");
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-js": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/create-custom-adorners/angular.md)
- [React](https://surveyjs.io/survey-creator/examples/create-custom-adorners/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/create-custom-adorners/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/create-custom-adorners/jquery.md)


---
title: Create Custom Adorners
product: Survey Creator
description: Custom adorner actions ensure even easier management of your survey elements right on the design surface. View a free demo example for JavaScript to learn more.
framework: React
source: https://surveyjs.io/survey-creator/examples/create-custom-adorners/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Create Custom Adorners (React)

Adorners are interactive design-surface controls placed within a question area. Adorners allow users to quickly execute the most common actions: duplicate a question, mark a question as required, or delete it. This demo shows how to customize built-in adorners and create custom adorners.

## Create a Button Adorner

A button adorner executes a simple action on click. To create a button adorner, follow the steps below:

1. Handle the [`onElementGetActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onElementGetActions) event.        
This event is raised when Survey Creator renders adorners on the design surface.

2. Create an `Action` instance.        
Pass an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) configuration object to the `Action` constructor. This object describes an action item rendered as a button adorner.

3. Add the `Action` instance to the `options.actions` array.       

This demo shows how to create a custom Read-Only button adorner. Refer to the code listing for more information. 

## Create a Drop-Down Adorner

A drop-down adorner opens a drop-down menu on click. The following instructions describe how to create a drop-down adorner:

1. Handle the [`onElementGetActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onElementGetActions) event.

2. Create an `Action` instance.     
Drop-down adorners have a dedicated `createDropdownActionModel()` helper function that generates `Action` instances based on [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) and `IActionDropdownPopupOptions` configuration objects. Import this function from `survey-core` and pass `IAction` and `IActionDropdownPopupOptions` objects to it.

3. Add the `Action` instance to the `options.actions` array.

In this demo, a custom Sort Order drop-down adorner lets users specify the order of items in choice-based questions. For details about implementation, view code listings for Angular, React, Vue, jQuery, or Vanilla JavaScript.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/survey_json.js`

```js
export const surveyJSON = {
  "elements": [
    {
      "type": "text",
      "name": "Single-Line Input"
    },
    {
      "type": "checkbox",
      "name": "Checkboxes",
      "choices": [
        "Item 1",
        "Item 2",
        "Item 3"
      ]
    }
  ]
};
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Serializer, Action, ComputedUpdater, createDropdownActionModel, QuestionSelectBase } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator();
    function createReadOnlyAction(question) {
        return new Action({
            id: "readOnly",
            active: new ComputedUpdater(() => question.readOnly),
            title: "Read-Only",
            iconName: "icon-editing-finish",        
            action: () => {
                question.readOnly = !question.readOnly;
            },
            // Place Read-Only before the Duplicate adorner whose `visibleIndex` is 10
            visibleIndex: 9
        });
    }
    function createSortOrderAction(selectBaseQuestion) {
        const sortOrderOptions = [
            { id: "none", title: "None" },
            { id: "asc", title: "Ascending" },
            { id: "desc", title: "Descending" },
            { id: "random", title: "Random" }
        ];
        function getTitle(selectBaseQuestion) {
            return sortOrderOptions.filter(
              (order) => order.id === selectBaseQuestion.choicesOrder
            )[0].title;
        }
        return createDropdownActionModel(
            {
                id: "sortOrder",   
                // Update a title caption to display the currently selected choice order
                title: new ComputedUpdater(() => {
                    return getTitle(selectBaseQuestion);
    
                }),
                // Place Sort Order before the custom Read-Only adorner
                visibleIndex: 8,
                // With the `sv-action--convertTo` class, a drop-down adorner
                // displays the selected value instead of the title
                css: "sv-action--convertTo sv-action-bar-item--secondary"            
            },
            {
                items: sortOrderOptions,
                allowSelection: true,
                onSelectionChanged: (item) => {
                    selectBaseQuestion.choicesOrder = item.id;
                },
                verticalPosition: "top",
                horizontalPosition: "center"
            }
        );
    }
    creator.onElementGetActions.add((_, options) => {
        const question = options.element;
        // Hide the titles of built-in adorners, except for "Element Type" and "Input Type"
        options.actions.forEach((action) => {
            if (["convertTo", "convertInputType"].indexOf(action.id) < 0) {
                action.showTitle = false;
            }
        });
        // Create a "Read-only" adorner for all question types
        const readOnlyAdorner = createReadOnlyAction(question);
        options.actions.push(readOnlyAdorner);
    
        // Create a "Sort Order" adorner for all choice-based questions
        if (question instanceof QuestionSelectBase) {
            const sortOrderAdorner = createSortOrderAction(question);
            options.actions.push(sortOrderAdorner);
        }
    });
    
    creator.JSON = surveyJSON;
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/create-custom-adorners/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/create-custom-adorners/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/create-custom-adorners/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/create-custom-adorners/vanillajs.md)


---
title: Create Custom Adorners
product: Survey Creator
description: Custom adorner actions ensure even easier management of your survey elements right on the design surface. View a free demo example for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/create-custom-adorners/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Create Custom Adorners (Angular)

Adorners are interactive design-surface controls placed within a question area. Adorners allow users to quickly execute the most common actions: duplicate a question, mark a question as required, or delete it. This demo shows how to customize built-in adorners and create custom adorners.

## Create a Button Adorner

A button adorner executes a simple action on click. To create a button adorner, follow the steps below:

1. Handle the [`onElementGetActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onElementGetActions) event.        
This event is raised when Survey Creator renders adorners on the design surface.

2. Create an `Action` instance.        
Pass an [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) configuration object to the `Action` constructor. This object describes an action item rendered as a button adorner.

3. Add the `Action` instance to the `options.actions` array.       

This demo shows how to create a custom Read-Only button adorner. Refer to the code listing for more information. 

## Create a Drop-Down Adorner

A drop-down adorner opens a drop-down menu on click. The following instructions describe how to create a drop-down adorner:

1. Handle the [`onElementGetActions`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#onElementGetActions) event.

2. Create an `Action` instance.     
Drop-down adorners have a dedicated `createDropdownActionModel()` helper function that generates `Action` instances based on [`IAction`](https://surveyjs.io/form-library/documentation/api-reference/iaction) and `IActionDropdownPopupOptions` configuration objects. Import this function from `survey-core` and pass `IAction` and `IActionDropdownPopupOptions` objects to it.

3. Add the `Action` instance to the `options.actions` array.

In this demo, a custom Sort Order drop-down adorner lets users specify the order of items in choice-based questions. For details about implementation, view code listings for Angular, React, Vue, jQuery, or Vanilla JavaScript.

## Files

### `src/app/components/creator.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/survey_json.js`

```js
export const surveyJSON = {
  "elements": [
    {
      "type": "text",
      "name": "Single-Line Input"
    },
    {
      "type": "checkbox",
      "name": "Checkboxes",
      "choices": [
        "Item 1",
        "Item 2",
        "Item 3"
      ]
    }
  ]
};
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { Serializer, Action, ComputedUpdater, createDropdownActionModel, QuestionSelectBase } from "survey-core";
import { surveyJSON } from "./survey_json";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel();
        function createReadOnlyAction(question) {
            return new Action({
                id: "readOnly",
                active: new ComputedUpdater(() => question.readOnly),
                title: "Read-Only",
                iconName: "icon-editing-finish",        
                action: () => {
                    question.readOnly = !question.readOnly;
                },
                // Place Read-Only before the Duplicate adorner whose `visibleIndex` is 10
                visibleIndex: 9
            });
        }
        function createSortOrderAction(selectBaseQuestion) {
            const sortOrderOptions = [
                { id: "none", title: "None" },
                { id: "asc", title: "Ascending" },
                { id: "desc", title: "Descending" },
                { id: "random", title: "Random" }
            ];
            function getTitle(selectBaseQuestion) {
                return sortOrderOptions.filter(
                  (order) => order.id === selectBaseQuestion.choicesOrder
                )[0].title;
            }
            return createDropdownActionModel(
                {
                    id: "sortOrder",   
                    // Update a title caption to display the currently selected choice order
                    title: new ComputedUpdater(() => {
                        return getTitle(selectBaseQuestion);
        
                    }),
                    // Place Sort Order before the custom Read-Only adorner
                    visibleIndex: 8,
                    // With the `sv-action--convertTo` class, a drop-down adorner
                    // displays the selected value instead of the title
                    css: "sv-action--convertTo sv-action-bar-item--secondary"            
                },
                {
                    items: sortOrderOptions,
                    allowSelection: true,
                    onSelectionChanged: (item) => {
                        selectBaseQuestion.choicesOrder = item.id;
                    },
                    verticalPosition: "top",
                    horizontalPosition: "center"
                }
            );
        }
        creator.onElementGetActions.add((_, options) => {
            const question = options.element;
            // Hide the titles of built-in adorners, except for "Element Type" and "Input Type"
            options.actions.forEach((action) => {
                if (["convertTo", "convertInputType"].indexOf(action.id) < 0) {
                    action.showTitle = false;
                }
            });
            // Create a "Read-only" adorner for all question types
            const readOnlyAdorner = createReadOnlyAction(question);
            options.actions.push(readOnlyAdorner);
        
            // Create a "Sort Order" adorner for all choice-based questions
            if (question instanceof QuestionSelectBase) {
                const sortOrderAdorner = createSortOrderAction(question);
                options.actions.push(sortOrderAdorner);
            }
        });
        
        creator.JSON = surveyJSON;
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/create-custom-adorners/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/create-custom-adorners/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/create-custom-adorners/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/create-custom-adorners/vanillajs.md)
